// アクセルON/OFFを繰り返し踏む動作を模擬
// (自動ブレーキのテスト用)

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/joystick.h>

#include <string.h>
#include <signal.h>
#include <errno.h>

#include <time.h>
//#include <sys/time.h>

#include "udp.h"

int main(int argc, char* argv[]) {
    if (argc != 3) {
        fprintf(stderr, "argument count mismatch error.\n");
        exit(EXIT_FAILURE);
    }

    /*** UDP Socketの初期化(ここから) ***/
    const char *address = argv[1];
    unsigned short port = (unsigned short)atoi(argv[2]);
    struct sockaddr servSockAddr, clitSockAddr;
    struct sigaction action;

    int server_sock = get_socket("udp");
    sockaddr_init(address, port, &servSockAddr);

    sigaction_init(&action, catchAlarm);
    if (sigaction(SIGALRM, &action, NULL) < 0) {
        perror("sigaction() failure");
        exit(EXIT_FAILURE);
    }
    /*** UDP Socketの初期化(ここまで) ***/

    struct timespec ts;
    ts.tv_sec = 0;
    ts.tv_nsec = 10000000;  // 10ms
    while (1) {
        char sendBuffer[MAX_BUFSIZE];
        char receiveBuffer[MAX_BUFSIZE];

        // アクセル(前進)を踏む
        int i;
        for (i=0; i<=100; i++) {
            sprintf(sendBuffer, "ACCEL=%f", i/100.0);
            udp_send(server_sock, sendBuffer, &servSockAddr);
            printf("%s\n", sendBuffer);
            // 10ms待つ
            nanosleep(&ts, NULL);
        }
        sleep(3);

        // アクセル(前進)を離す
        for (i=100; i>=0; i--) {
            sprintf(sendBuffer, "ACCEL=%f", i/100.0);
            udp_send(server_sock, sendBuffer, &servSockAddr);
            printf("%s\n", sendBuffer);
            // 10ms待つ
            nanosleep(&ts, NULL);
        }
        sleep(3);
    }

    // 終了処理
    return 0;
}

